diff --git a/testsuite/des-test.c b/testsuite/des-test.c
index 244e5aa..4d1ce64 100644
--- a/testsuite/des-test.c
+++ b/testsuite/des-test.c
@@ -2,12 +2,18 @@
 #include "nettle-internal.h"
 #include "des.h"
 
+#define STR_TO_HEX(a) encode_hex_dup(a, strlen(a))
+
 static void
-test_des(const uint8_t *key, int expected_parity,
-	 unsigned length,
-	 const uint8_t *cleartext,
-	 const uint8_t *ciphertext)
+test_des(const uint8_t *key_hex, int expected_parity,
+	 const uint8_t *cleartext_hex,
+	 const uint8_t *ciphertext_hex)
 {
+  const uint8_t *key = decode_hex_dup(key_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+
   struct des_ctx ctx;
   uint8_t *data = xalloc(length);
 
@@ -46,77 +52,98 @@ test_des(const uint8_t *key, int expected_parity,
     }
 
   free(data);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)key);
+}
+
+static int
+test_des_check_parity(const uint8_t *key_hex)
+{
+  unsigned length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  int rc = des_check_parity(8, key);
+
+  free((void *)key);
+  return rc;
 }
 
 static void
-test_weak(const uint8_t *key)
+test_weak(const uint8_t *key_hex)
 {
   struct des_ctx ctx;
+  const uint8_t *key = decode_hex_dup(key_hex);
 
   if (des_set_key(&ctx, key))
     FAIL();
+
+  free((void *)key);
 }
 
 int
 test_main(void)
 {
+  const uint8_t *cleartext_hex = STR_TO_HEX("Now is t");
+
   /* From Applied Cryptography */
-  test_des(H("01234567 89ABCDEF"), 1,
-	   HL("01234567 89ABCDE7"),
-	   H("C9574425 6A5ED31D"));
+  test_des("01234567 89ABCDEF", 1,
+	   "01234567 89ABCDE7",
+	   "C9574425 6A5ED31D");
 
-  test_des(H("01 01 01 01 01 01 01 80"), 1,
-	   HL("00 00 00 00 00 00 00 00"),
-	   H("9C C6 2D F4 3B 6E ED 74"));
+  test_des("01 01 01 01 01 01 01 80", 1,
+	   "00 00 00 00 00 00 00 00",
+	   "9C C6 2D F4 3B 6E ED 74");
 
-  test_des(H("80 01 01 01 01 01 01 01"), 1,
-	   HL("00 00 00 00 00 00 00 40"),
-	   H("A3 80 E0 2A 6B E5 46 96"));
+  test_des("80 01 01 01 01 01 01 01", 1,
+	   "00 00 00 00 00 00 00 40",
+	   "A3 80 E0 2A 6B E5 46 96");
 
-  test_des(H("08 19 2A 3B 4C 5D 6E 7F"), 1,
-	   HL("00 00 00 00 00 00 00 00"),
-	   H("25 DD AC 3E 96 17 64 67"));
+  test_des("08 19 2A 3B 4C 5D 6E 7F", 1,
+	   "00 00 00 00 00 00 00 00",
+	   "25 DD AC 3E 96 17 64 67");
 
-  test_des(H("01 23 45 67 89 AB CD EF"), 1,
-	   DES_BLOCK_SIZE, "Now is t",
-	   H("3F A4 0E 8A 98 4D 48 15"));
+  test_des("01 23 45 67 89 AB CD EF", 1,
+	   cleartext_hex,
+	   "3F A4 0E 8A 98 4D 48 15");
 
   /* Same key, but with one bad parity bit, */
-  test_des(H("01 23 45 66 89 AB CD EF"), 0,
-	   DES_BLOCK_SIZE, "Now is t",
-	   H("3F A4 0E 8A 98 4D 48 15"));
+  test_des("01 23 45 66 89 AB CD EF", 0,
+	   cleartext_hex,
+	   "3F A4 0E 8A 98 4D 48 15");
 
   /* Parity check */
-  if (des_check_parity(HL("01 01 01 01 01 01 01 00")))
+  if (test_des_check_parity("01 01 01 01 01 01 01 00"))
     FAIL();
 
   /* The four weak keys */
-  test_weak(H("01 01 01 01 01 01 01 01"));  
-  test_weak(H("FE FE FE FE FE FE FE FE"));
-  test_weak(H("1F 1F 1F 1F 0E 0E 0E 0E"));
-  test_weak(H("E0 E0 E0 E0 F1 F1 F1 F1"));
+  test_weak("01 01 01 01 01 01 01 01");  
+  test_weak("FE FE FE FE FE FE FE FE");
+  test_weak("1F 1F 1F 1F 0E 0E 0E 0E");
+  test_weak("E0 E0 E0 E0 F1 F1 F1 F1");
 
   /* Same weak key, but different parity. */
-  test_weak(H("E0 E0 E0 E0 F0 F1 F1 F1"));
+  test_weak("E0 E0 E0 E0 F0 F1 F1 F1");
 
   /* The six pairs of semiweak keys */
-  test_weak(H("01 FE 01 FE 01 FE 01 FE"));
-  test_weak(H("FE 01 FE 01 FE 01 FE 01"));
+  test_weak("01 FE 01 FE 01 FE 01 FE");
+  test_weak("FE 01 FE 01 FE 01 FE 01");
+
+  test_weak("1F E0 1F E0 0E F1 0E F1");
+  test_weak("E0 1F E0 1F F1 0E F1 0E");
 
-  test_weak(H("1F E0 1F E0 0E F1 0E F1"));
-  test_weak(H("E0 1F E0 1F F1 0E F1 0E"));
+  test_weak("01 E0 01 E0 01 F1 01 F1");
+  test_weak("E0 01 E0 01 F1 01 F1 01");
 
-  test_weak(H("01 E0 01 E0 01 F1 01 F1"));
-  test_weak(H("E0 01 E0 01 F1 01 F1 01"));
+  test_weak("1F FE 1F FE 0E FE 0E FE");
+  test_weak("FE 1F FE 1F FE 0E FE 0E");
 
-  test_weak(H("1F FE 1F FE 0E FE 0E FE"));
-  test_weak(H("FE 1F FE 1F FE 0E FE 0E"));
+  test_weak("01 1F 01 1F 01 0E 01 0E");
+  test_weak("1F 01 1F 01 0E 01 0E 01");
 
-  test_weak(H("01 1F 01 1F 01 0E 01 0E"));
-  test_weak(H("1F 01 1F 01 0E 01 0E 01"));
+  test_weak("E0 FE E0 FE F1 FE F1 FE");
+  test_weak("FE E0 FE E0 FE F1 FE F1");
 
-  test_weak(H("E0 FE E0 FE F1 FE F1 FE"));
-  test_weak(H("FE E0 FE E0 FE F1 FE F1"));
+  free((void *)cleartext_hex);
 
   SUCCESS();
 }
diff --git a/testsuite/des3-test.c b/testsuite/des3-test.c
index 678a235..796e776 100644
--- a/testsuite/des3-test.c
+++ b/testsuite/des3-test.c
@@ -2,20 +2,26 @@
 #include "nettle-internal.h"
 #include "des.h"
 
+#define STR_TO_HEX(a) encode_hex_dup(a, strlen(a))
+
 int
 test_main(void)
 {
+  const uint8_t *cleartext_hex = STR_TO_HEX("Now is t");
+
   /* Intermediate values:
    *   After first DES encryption:  "cd ea 2a 20 c2 e0 9e 48"
    *   After second DES decryption: "69 52 6e 95 8b ea 49 bd"
    */
 
   test_cipher(&nettle_des3,
-	      HL("3e 0b 10 b0 5d 49 c2 54"
+	      "3e 0b 10 b0 5d 49 c2 54"
 		 "6b 46 e0 75 8a 91 61 85"
-		 "cb 04 07 d3 20 16 cb a2"),
-	      DES_BLOCK_SIZE, "Now is t",
-	      H("0a 5d b5 2d 85 74 d1 c9"));
+		 "cb 04 07 d3 20 16 cb a2",
+	      cleartext_hex,
+	      "0a 5d b5 2d 85 74 d1 c9");
+
+  free((void *)cleartext_hex);
 
   SUCCESS();
 }
diff --git a/testsuite/gcm-test.c b/testsuite/gcm-test.c
index a1cf964..ef82f39 100644
--- a/testsuite/gcm-test.c
+++ b/testsuite/gcm-test.c
@@ -12,267 +12,267 @@ test_main(void)
 
   /* Test case 1 */
   test_aead(&nettle_gcm_aes128,
-	    /* key */HL("00000000000000000000000000000000"),
-	    /* auth data */ HL(""),
-	    /* plaintext */HL(""),
-	    /* ciphertext*/H(""),
-	    /* IV */HL("000000000000000000000000"),
-	    /* tag */H("58e2fccefa7e3061367f1d57a4e7455a"));
+	    /* key */"00000000000000000000000000000000",
+	    /* auth data */ "",
+	    /* plaintext */"",
+	    /* ciphertext*/"",
+	    /* IV */"000000000000000000000000",
+	    /* tag */"58e2fccefa7e3061367f1d57a4e7455a");
 
   /* Test case 2 */
   test_aead(&nettle_gcm_aes128,
-	    HL("00000000000000000000000000000000"),
-	    HL(""),
-	    HL("00000000000000000000000000000000"),
-	    H("0388dace60b6a392f328c2b971b2fe78"),
-	    HL("000000000000000000000000"),
-	    H("ab6e47d42cec13bdf53a67b21257bddf"));
+	    "00000000000000000000000000000000",
+	    "",
+	    "00000000000000000000000000000000",
+	    "0388dace60b6a392f328c2b971b2fe78",
+	    "000000000000000000000000",
+	    "ab6e47d42cec13bdf53a67b21257bddf");
 
   /* Test case 3 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"),
-	    HL(""),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308",
+	    "",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b391aafd255"),
-	    H("42831ec2217774244b7221b784d0d49c"
+	       "b16aedf5aa0de657ba637b391aafd255",
+	    "42831ec2217774244b7221b784d0d49c"
 	      "e3aa212f2c02a4e035c17e2329aca12e"
 	      "21d514b25466931c7d8f6a5aac84aa05"
-	      "1ba30b396a0aac973d58e091473f5985"),
-	    HL("cafebabefacedbaddecaf888"),
-	    H("4d5c2af327cd64a62cf35abd2ba6fab4"));
+	      "1ba30b396a0aac973d58e091473f5985",
+	    "cafebabefacedbaddecaf888",
+	    "4d5c2af327cd64a62cf35abd2ba6fab4");
 
   /* Test case 4 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"),
-	    HL("feedfacedeadbeeffeedfacedeadbeef"
-	       "abaddad2"),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308",
+	    "feedfacedeadbeeffeedfacedeadbeef"
+	       "abaddad2",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b39"),
-	    H("42831ec2217774244b7221b784d0d49c"
+	       "b16aedf5aa0de657ba637b39",
+	    "42831ec2217774244b7221b784d0d49c"
 	      "e3aa212f2c02a4e035c17e2329aca12e"
 	      "21d514b25466931c7d8f6a5aac84aa05"
-	      "1ba30b396a0aac973d58e091"),
-	    HL("cafebabefacedbaddecaf888"),
-	    H("5bc94fbc3221a5db94fae95ae7121a47"));
+	      "1ba30b396a0aac973d58e091",
+	    "cafebabefacedbaddecaf888",
+	    "5bc94fbc3221a5db94fae95ae7121a47");
 
   /* Test case 5 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"),
-	    HL("feedfacedeadbeeffeedfacedeadbeef"
-	       "abaddad2"),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308",
+	    "feedfacedeadbeeffeedfacedeadbeef"
+	       "abaddad2",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b39"),
-	    H("61353b4c2806934a777ff51fa22a4755"
+	       "b16aedf5aa0de657ba637b39",
+	    "61353b4c2806934a777ff51fa22a4755"
 	      "699b2a714fcdc6f83766e5f97b6c7423"
 	      "73806900e49f24b22b097544d4896b42"
-	      "4989b5e1ebac0f07c23f4598"),
-	    HL("cafebabefacedbad"),
-	    H("3612d2e79e3b0785561be14aaca2fccb"));
+	      "4989b5e1ebac0f07c23f4598",
+	    "cafebabefacedbad",
+	    "3612d2e79e3b0785561be14aaca2fccb");
 
   /* Test case 6 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"),
-	    HL("feedfacedeadbeeffeedfacedeadbeef"
-	       "abaddad2"),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308",
+	    "feedfacedeadbeeffeedfacedeadbeef"
+	       "abaddad2",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b39"),
-	    H("8ce24998625615b603a033aca13fb894"
+	       "b16aedf5aa0de657ba637b39",
+	    "8ce24998625615b603a033aca13fb894"
 	      "be9112a5c3a211a8ba262a3cca7e2ca7"
 	      "01e4a9a4fba43c90ccdcb281d48c7c6f"
-	      "d62875d2aca417034c34aee5"),
-	    HL("9313225df88406e555909c5aff5269aa"
+	      "d62875d2aca417034c34aee5",
+	    "9313225df88406e555909c5aff5269aa"
 	       "6a7a9538534f7da1e4c303d2a318a728"
 	       "c3c0c95156809539fcf0e2429a6b5254"
-	       "16aedbf5a0de6a57a637b39b"),
-	    H("619cc5aefffe0bfa462af43c1699d050"));
+	       "16aedbf5a0de6a57a637b39b",
+	    "619cc5aefffe0bfa462af43c1699d050");
   
   /* Test case 7 */
   test_aead(&nettle_gcm_aes128,
-	    HL("00000000000000000000000000000000"
-	       "0000000000000000"),
-	    HL(""),
-	    HL(""),
-	    H(""),
-	    HL("000000000000000000000000"),
-	    H("cd33b28ac773f74ba00ed1f312572435"));
+	    "00000000000000000000000000000000"
+	       "0000000000000000",
+	    "",
+	    "",
+	    "",
+	    "000000000000000000000000",
+	    "cd33b28ac773f74ba00ed1f312572435");
 
   /* Test case 8 */
   test_aead(&nettle_gcm_aes128,
-	    HL("00000000000000000000000000000000"
-	       "0000000000000000"),
-	    HL(""),
-	    HL("00000000000000000000000000000000"),
-	    H("98e7247c07f0fe411c267e4384b0f600"),
-	    HL("000000000000000000000000"),
-	    H("2ff58d80033927ab8ef4d4587514f0fb"));
+	    "00000000000000000000000000000000"
+	       "0000000000000000",
+	    "",
+	    "00000000000000000000000000000000",
+	    "98e7247c07f0fe411c267e4384b0f600",
+	    "000000000000000000000000",
+	    "2ff58d80033927ab8ef4d4587514f0fb");
 
   /* Test case 9 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"
-	       "feffe9928665731c"),
-	    HL(""),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308"
+	       "feffe9928665731c",
+	    "",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b391aafd255"),
-	    H("3980ca0b3c00e841eb06fac4872a2757"
+	       "b16aedf5aa0de657ba637b391aafd255",
+	    "3980ca0b3c00e841eb06fac4872a2757"
 	      "859e1ceaa6efd984628593b40ca1e19c"
 	      "7d773d00c144c525ac619d18c84a3f47"
-	      "18e2448b2fe324d9ccda2710acade256"),
-	    HL("cafebabefacedbaddecaf888"),
-	    H("9924a7c8587336bfb118024db8674a14"));
+	      "18e2448b2fe324d9ccda2710acade256",
+	    "cafebabefacedbaddecaf888",
+	    "9924a7c8587336bfb118024db8674a14");
 
   /* Test case 10 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"
-	       "feffe9928665731c"),
-	    HL("feedfacedeadbeeffeedfacedeadbeef"
-	       "abaddad2"),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308"
+	       "feffe9928665731c",
+	    "feedfacedeadbeeffeedfacedeadbeef"
+	       "abaddad2",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b39"),
-	    H("3980ca0b3c00e841eb06fac4872a2757"
+	       "b16aedf5aa0de657ba637b39",
+	    "3980ca0b3c00e841eb06fac4872a2757"
 	      "859e1ceaa6efd984628593b40ca1e19c"
 	      "7d773d00c144c525ac619d18c84a3f47"
-	      "18e2448b2fe324d9ccda2710"),
-	    HL("cafebabefacedbaddecaf888"),
-	    H("2519498e80f1478f37ba55bd6d27618c"));
+	      "18e2448b2fe324d9ccda2710",
+	    "cafebabefacedbaddecaf888",
+	    "2519498e80f1478f37ba55bd6d27618c");
 
   /* Test case 11 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"
-	       "feffe9928665731c"),
-	    HL("feedfacedeadbeeffeedfacedeadbeef"
-	       "abaddad2"),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308"
+	       "feffe9928665731c",
+	    "feedfacedeadbeeffeedfacedeadbeef"
+	       "abaddad2",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b39"),
-	    H("0f10f599ae14a154ed24b36e25324db8"
+	       "b16aedf5aa0de657ba637b39",
+	    "0f10f599ae14a154ed24b36e25324db8"
 	      "c566632ef2bbb34f8347280fc4507057"
 	      "fddc29df9a471f75c66541d4d4dad1c9"
-	      "e93a19a58e8b473fa0f062f7"),
-	    HL("cafebabefacedbad"),
-	    H("65dcc57fcf623a24094fcca40d3533f8"));
+	      "e93a19a58e8b473fa0f062f7",
+	    "cafebabefacedbad",
+	    "65dcc57fcf623a24094fcca40d3533f8");
 
   /* Test case 12 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"
-	       "feffe9928665731c"),
-	    HL("feedfacedeadbeeffeedfacedeadbeef"
-	       "abaddad2"),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308"
+	       "feffe9928665731c",
+	    "feedfacedeadbeeffeedfacedeadbeef"
+	       "abaddad2",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b39"),
-	    H("d27e88681ce3243c4830165a8fdcf9ff"
+	       "b16aedf5aa0de657ba637b39",
+	    "d27e88681ce3243c4830165a8fdcf9ff"
 	      "1de9a1d8e6b447ef6ef7b79828666e45"
 	      "81e79012af34ddd9e2f037589b292db3"
-	      "e67c036745fa22e7e9b7373b"),
-	    HL("9313225df88406e555909c5aff5269aa"
+	      "e67c036745fa22e7e9b7373b",
+	    "9313225df88406e555909c5aff5269aa"
 	       "6a7a9538534f7da1e4c303d2a318a728"
 	       "c3c0c95156809539fcf0e2429a6b5254"
-	       "16aedbf5a0de6a57a637b39b"),
-	    H("dcf566ff291c25bbb8568fc3d376a6d9"));
+	       "16aedbf5a0de6a57a637b39b",
+	    "dcf566ff291c25bbb8568fc3d376a6d9");
 
   /* Test case 13 */
   test_aead(&nettle_gcm_aes128,
-	    HL("00000000000000000000000000000000"
-	       "00000000000000000000000000000000"),
-	    HL(""),
-	    HL(""),
-	    H(""),
-	    HL("000000000000000000000000"),
-	    H("530f8afbc74536b9a963b4f1c4cb738b"));
+	    "00000000000000000000000000000000"
+	       "00000000000000000000000000000000",
+	    "",
+	    "",
+	    "",
+	    "000000000000000000000000",
+	    "530f8afbc74536b9a963b4f1c4cb738b");
 
   /* Test case 14 */
   test_aead(&nettle_gcm_aes128,
-	    HL("00000000000000000000000000000000"
-	       "00000000000000000000000000000000"),
-	    HL(""),
-	    HL("00000000000000000000000000000000"),
-	    H("cea7403d4d606b6e074ec5d3baf39d18"),
-	    HL("000000000000000000000000"),
-	    H("d0d1c8a799996bf0265b98b5d48ab919"));
+	    "00000000000000000000000000000000"
+	       "00000000000000000000000000000000",
+	    "",
+	    "00000000000000000000000000000000",
+	    "cea7403d4d606b6e074ec5d3baf39d18",
+	    "000000000000000000000000",
+	    "d0d1c8a799996bf0265b98b5d48ab919");
 
   /* Test case 15 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"
-	       "feffe9928665731c6d6a8f9467308308"),
-	    HL(""),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308"
+	       "feffe9928665731c6d6a8f9467308308",
+	    "",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b391aafd255"),
-	    H("522dc1f099567d07f47f37a32a84427d"
+	       "b16aedf5aa0de657ba637b391aafd255",
+	    "522dc1f099567d07f47f37a32a84427d"
 	      "643a8cdcbfe5c0c97598a2bd2555d1aa"
 	      "8cb08e48590dbb3da7b08b1056828838"
-	      "c5f61e6393ba7a0abcc9f662898015ad"),
-	    HL("cafebabefacedbaddecaf888"),
-	    H("b094dac5d93471bdec1a502270e3cc6c"));
+	      "c5f61e6393ba7a0abcc9f662898015ad",
+	    "cafebabefacedbaddecaf888",
+	    "b094dac5d93471bdec1a502270e3cc6c");
 
   /* Test case 16 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"
-	       "feffe9928665731c6d6a8f9467308308"),
-	    HL("feedfacedeadbeeffeedfacedeadbeef"
-	       "abaddad2"),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308"
+	       "feffe9928665731c6d6a8f9467308308",
+	    "feedfacedeadbeeffeedfacedeadbeef"
+	       "abaddad2",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b39"),
-	    H("522dc1f099567d07f47f37a32a84427d"
+	       "b16aedf5aa0de657ba637b39",
+	    "522dc1f099567d07f47f37a32a84427d"
 	      "643a8cdcbfe5c0c97598a2bd2555d1aa"
 	      "8cb08e48590dbb3da7b08b1056828838"
-	      "c5f61e6393ba7a0abcc9f662"),
-	    HL("cafebabefacedbaddecaf888"),
-	    H("76fc6ece0f4e1768cddf8853bb2d551b"));
+	      "c5f61e6393ba7a0abcc9f662",
+	    "cafebabefacedbaddecaf888",
+	    "76fc6ece0f4e1768cddf8853bb2d551b");
 
   /* Test case 17 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"
-	       "feffe9928665731c6d6a8f9467308308"),
-	    HL("feedfacedeadbeeffeedfacedeadbeef"
-	       "abaddad2"),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308"
+	       "feffe9928665731c6d6a8f9467308308",
+	    "feedfacedeadbeeffeedfacedeadbeef"
+	       "abaddad2",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b39"),
-	    H("c3762df1ca787d32ae47c13bf19844cb"
+	       "b16aedf5aa0de657ba637b39",
+	    "c3762df1ca787d32ae47c13bf19844cb"
 	      "af1ae14d0b976afac52ff7d79bba9de0"
 	      "feb582d33934a4f0954cc2363bc73f78"
-	      "62ac430e64abe499f47c9b1f"),
-	    HL("cafebabefacedbad"),
-	    H("3a337dbf46a792c45e454913fe2ea8f2"));
+	      "62ac430e64abe499f47c9b1f",
+	    "cafebabefacedbad",
+	    "3a337dbf46a792c45e454913fe2ea8f2");
 
   /* Test case 18 */
   test_aead(&nettle_gcm_aes128,
-	    HL("feffe9928665731c6d6a8f9467308308"
-	       "feffe9928665731c6d6a8f9467308308"),
-	    HL("feedfacedeadbeeffeedfacedeadbeef"
-	       "abaddad2"),
-	    HL("d9313225f88406e5a55909c5aff5269a"
+	    "feffe9928665731c6d6a8f9467308308"
+	       "feffe9928665731c6d6a8f9467308308",
+	    "feedfacedeadbeeffeedfacedeadbeef"
+	       "abaddad2",
+	    "d9313225f88406e5a55909c5aff5269a"
 	       "86a7a9531534f7da2e4c303d8a318a72"
 	       "1c3c0c95956809532fcf0e2449a6b525"
-	       "b16aedf5aa0de657ba637b39"),
-	    H("5a8def2f0c9e53f1f75d7853659e2a20"
+	       "b16aedf5aa0de657ba637b39",
+	    "5a8def2f0c9e53f1f75d7853659e2a20"
 	      "eeb2b22aafde6419a058ab4f6f746bf4"
 	      "0fc0c3b780f244452da3ebf1c5d82cde"
-	      "a2418997200ef82e44ae7e3f"),
-	    HL("9313225df88406e555909c5aff5269aa"
+	      "a2418997200ef82e44ae7e3f",
+	    "9313225df88406e555909c5aff5269aa"
 	       "6a7a9538534f7da1e4c303d2a318a728"
 	       "c3c0c95156809539fcf0e2429a6b5254"
-	       "16aedbf5a0de6a57a637b39b"),
-	    H("a44a8266ee1c8eb0c8b5d4cf5ae9f19a"));
+	       "16aedbf5a0de6a57a637b39b",
+	    "a44a8266ee1c8eb0c8b5d4cf5ae9f19a");
 
   SUCCESS();
 }
